//--------------------------------------------------------------
// Press F1 to get help about using script.
// To access an object that is not located in the current class, start the call with Globals.
// When using events and timers be cautious not to generate memoryleaks,
// please see the help for more information.
//---------------------------------------------------------------

    /*
	*******************************************************************
	All examples in this support document are only intended
	to improve understanding of the functionality and 
	handling of the equipment. 
	Beijer Electronics AB cannot assume any liability if these
	examples are used in real applications.
	In view of the wide range of applications for this 
	equipment, users must acquire sufficient knowledge 
	themselves in order to ensure that it is correctly used in 
	their specific application. Persons responsible for the 
	application and the equipment must themselves 
	ensure that each application is in compliance with all 
	relevant requirements, standards and legislation in 
	respect to configuration and safety.
	Beijer Electronics AB will accept no liability for any 
	damage incurred during the installation or use of this 
	equipment.
	Beijer Electronics AB prohibits all modification, changes
	or conversion of the equipment.
	*******************************************************************
	*/

namespace Neo.ApplicationFramework.Generated
{
	using System.Windows.Forms;
	using System;
	using System.Drawing;
	using Neo.ApplicationFramework.Tools;
	using Neo.ApplicationFramework.Common.Graphics.Logic;
	using Neo.ApplicationFramework.Controls;
	using Neo.ApplicationFramework.Interfaces;
	
   
    public partial class Scr_Home
    {
		private Form GraphForm = null;
		private System.Drawing.Graphics formGraphics = null;
		private System.Drawing.SolidBrush currentBrush = null;
		private System.Drawing.SolidBrush BlackBrush = null;
		private System.Drawing.SolidBrush WhiteBrush = null;
		private System.Drawing.SolidBrush LightGrayBrush = null;
		private System.Drawing.SolidBrush GrayBrush = null;		
		private System.Drawing.SolidBrush BlueBrush = null;
		private System.Drawing.SolidBrush LightGreenBrush = null;
		private System.Drawing.SolidBrush GreenBrush = null;
		private System.Drawing.SolidBrush RedBrush = null;
		private System.Drawing.SolidBrush YellowBrush = null;
		private System.Drawing.SolidBrush OrangeBrush = null;
		private System.Drawing.Pen currentPen = null;
		private System.Drawing.Pen BluePen = null;
		private System.Drawing.Pen RedPen = null;
		private System.Drawing.Pen BlackPen = null;
		private System.Drawing.Pen WhitePen = null;
		private System.Drawing.Pen YellowPen = null;
		private System.Drawing.Pen GrayPen = null;
		private System.Drawing.Pen GreenPen = null;
		private System.Drawing.Pen OrangePen = null;
		private System.Drawing.Font drawFont = null;
		
		// ********** Mouse **********
		protected override void OnMouseDown(MouseEventArgs e)
		{
			Globals.Tags.dx.Value = e.X;
			Globals.Tags.dy.Value = e.Y;
			if(Globals.Tags.dy.Value > 60)
			{
				Globals.Tags.x2.Value = Globals.Tags.x1.Value;
				Globals.Tags.y2.Value = Globals.Tags.y1.Value;
				Globals.Tags.x1.Value = e.X;
				Globals.Tags.y1.Value = e.Y;
				Trace();
			}
			base.OnMouseDown(e); //Forward the event to base objects
		}
		
		protected override void OnMouseMove(MouseEventArgs e)
		{
			Globals.Tags.dx.Value = e.X;
			Globals.Tags.dy.Value = e.Y;
			base.OnMouseMove(e); //Forward the event to base objects
		}

		//****************************************************************************************
		public void SetFormHandle (Form m_Form)
		{
			GraphForm = m_Form;
			CreateGraph();
		}
		
		//****************************************************************************************
		private void CreateGraph()
		{
			//http://www.flounder.com/csharp_color_table.htm
			if (formGraphics == null)
			{ 
				//Form Graphic
				formGraphics = GraphForm.CreateGraphics();
			
				//Brush
				BlackBrush = new System.Drawing.SolidBrush(System.Drawing.Color.Black);
				WhiteBrush = new System.Drawing.SolidBrush(System.Drawing.Color.White);
				LightGrayBrush = new System.Drawing.SolidBrush(System.Drawing.Color.LightGray);
				GrayBrush = new System.Drawing.SolidBrush(System.Drawing.Color.DarkGray);
				BlueBrush = new System.Drawing.SolidBrush(System.Drawing.Color.LightSkyBlue);
				GreenBrush = new System.Drawing.SolidBrush(System.Drawing.Color.Green);
				LightGreenBrush = new System.Drawing.SolidBrush(System.Drawing.Color.LightGreen);
				RedBrush = new System.Drawing.SolidBrush(System.Drawing.Color.Red);
				YellowBrush = new System.Drawing.SolidBrush(System.Drawing.Color.Yellow);
				OrangeBrush = new System.Drawing.SolidBrush(System.Drawing.Color.OrangeRed);
				currentBrush = GreenBrush;
				//Pen
				BluePen = new Pen(Color.Blue, 1);
				RedPen = new Pen(Color.Red, 1);
				BlackPen = new Pen(Color.Black, 1);
				WhitePen = new Pen(Color.White, 1);
				YellowPen = new Pen(Color.Yellow, 1);
				GrayPen = new Pen(Color.DarkGray, 1);
				GreenPen = new Pen(Color.LightGreen, 1);
				OrangePen = new Pen(Color.OrangeRed, 1);
				drawFont = new Font("Arial", 14.0f, FontStyle.Regular);
				currentPen = BlackPen;
			}
		}

		//****************************************************************************************
		public void DisposeGraph()
		{
			if (formGraphics != null) { formGraphics.Dispose(); formGraphics = null; }
			//Brush
			if (currentBrush != null) { currentBrush.Dispose(); currentBrush = null; }
			if (BlackBrush != null) { BlackBrush.Dispose(); BlackBrush = null; }
			if (WhiteBrush != null) { WhiteBrush.Dispose(); WhiteBrush = null; }
			if (LightGrayBrush != null) { LightGrayBrush.Dispose(); LightGrayBrush = null; }
			if (GrayBrush != null) { GrayBrush.Dispose(); GrayBrush = null; }
			if (BlueBrush != null) { BlueBrush.Dispose(); BlueBrush = null; }
			if (GreenBrush != null) { GreenBrush.Dispose(); GreenBrush = null; }
			if (LightGreenBrush != null) { LightGreenBrush.Dispose(); LightGreenBrush = null; }
			if (RedBrush != null) { RedBrush.Dispose(); RedBrush = null; }
			if (YellowBrush != null) { YellowBrush.Dispose(); YellowBrush = null; }
			if (OrangeBrush != null) { OrangeBrush.Dispose(); OrangeBrush = null; }
			//Pen
			if (currentPen != null) { currentPen.Dispose(); currentPen = null; }
			if (BluePen != null) { BluePen.Dispose(); BluePen = null; }
			if (RedPen != null) { RedPen.Dispose(); RedPen = null; }
			if (BlackPen != null) { BlackPen.Dispose(); BlackPen = null; }
			if (WhitePen != null) { WhitePen.Dispose(); WhitePen = null; }
			if (YellowPen != null) { YellowPen.Dispose(); YellowPen = null; }
			if (GrayPen != null) { GrayPen.Dispose(); GrayPen = null; }
			if (GreenPen != null) { GreenPen.Dispose(); GreenPen = null; }
			if (OrangePen != null) { OrangePen.Dispose(); OrangePen = null; }
			//Font
			if (drawFont != null) { drawFont.Dispose(); drawFont = null; }
		}
		
		//****************************************************************************************
		void Scr_Home_Opened(System.Object sender, System.EventArgs e)
		{
			Globals.Tags.x1.Value = -1;
			Globals.Tags.x2.Value = -1;
			Globals.Tags.y1.Value = -1;
			Globals.Tags.y2.Value = -1;
			SetFormHandle(this);
		}
				
		//****************************************************************************************
		int Type = 0;
		void btnType_Click(System.Object sender, System.EventArgs e)
		{
			Type++;
			if (Type > 5) { Type = 0; btnType.Text = "Line"; Init(); }
			if(Type == 1) { btnType.Text = "Rectangle"; Init(); }
			if(Type == 2) { btnType.Text = "Ellipse"; Init(); }
			if(Type == 3) { btnType.Text = "FillRectangle"; Init(); }
			if(Type == 4) { btnType.Text = "FillEllipse"; Init(); }
			if(Type == 5) { btnType.Text = "Text"; Init(); }
		}
		
		//****************************************************************************************
		void Init()
		{
			Globals.Tags.x1.Value = -1;
			Globals.Tags.x2.Value = -1;
			Globals.Tags.y1.Value = -1;
			Globals.Tags.y2.Value = -1;
		}
		
		//****************************************************************************************
		void Trace()
		{
			if(Type == 5 && Globals.Tags.dy.Value > 60 && Globals.Tags.dy.Value < 440) //Text
			{
				if(Globals.Tags.x1.Value >= 0)
				{
					formGraphics.DrawString(
						Globals.Tags.myText.Value,
						drawFont,
						currentBrush,
						new Rectangle(
						Globals.Tags.x1.Value,
						Globals.Tags.y1.Value,
						800,
						40));
					Init();
				}
			}
			else if(Globals.Tags.x1.Value >= 0 && Globals.Tags.x2.Value >= 0)
			{
				if(Globals.Tags.dy.Value > 60 && Globals.Tags.dy.Value < 440)
				{
					//Line
					if(Type == 0)
					{
						formGraphics.DrawLine(
							currentPen,
							Globals.Tags.x1.Value,
							Globals.Tags.y1.Value,
							Globals.Tags.x2.Value,
							Globals.Tags.y2.Value);
					}
					
					//Rectangle
					if(Type == 1)
					{
						formGraphics.DrawRectangle(
							currentPen,
							Globals.Tags.x2.Value,
							Globals.Tags.y2.Value,
							Globals.Tags.x1.Value - Globals.Tags.x2.Value,
							Globals.Tags.y1.Value - Globals.Tags.y2.Value);
						
						Init();
					}
					
					//Ellipse
					if(Type == 2)
					{
						formGraphics.DrawEllipse(
							currentPen,
							Globals.Tags.x2.Value,
							Globals.Tags.y2.Value,
							Globals.Tags.x1.Value - Globals.Tags.x2.Value,
							Globals.Tags.y1.Value - Globals.Tags.y2.Value);
						
						Init();
					}
					
					//Fill Rectangle
					if(Type == 3)
					{
						formGraphics.FillRectangle(
							currentBrush,
							new Rectangle(
							Globals.Tags.x2.Value,
							Globals.Tags.y2.Value,
							Globals.Tags.x1.Value - Globals.Tags.x2.Value,
							Globals.Tags.y1.Value - Globals.Tags.y2.Value));
						Init();
					}
					
					//Fill Ellipse
					if(Type == 4)
					{
						formGraphics.FillEllipse(
							currentBrush,
							new Rectangle(
							Globals.Tags.x2.Value,
							Globals.Tags.y2.Value,
							Globals.Tags.x1.Value - Globals.Tags.x2.Value,
							Globals.Tags.y1.Value - Globals.Tags.y2.Value));
						Init();
					}
				}
			}
		}
		
		void btnStop_Click(System.Object sender, System.EventArgs e)
		{
			Init();
		}
		
		void btnBlack_Click(System.Object sender, System.EventArgs e)
		{
			currentPen = BlackPen;
			currentBrush = BlackBrush;
		}
		
		void btnRed_Click(System.Object sender, System.EventArgs e)
		{
			currentPen = RedPen;
			currentBrush = RedBrush;
		}
		
		void btnYellow_Click(System.Object sender, System.EventArgs e)
		{
			currentPen = YellowPen;
			currentBrush = YellowBrush;
		}
		
		void btnBlue_Click(System.Object sender, System.EventArgs e)
		{
			currentPen = BluePen;
			currentBrush = BlueBrush;
		}
		
		void btnGreen_Click(System.Object sender, System.EventArgs e)
		{
			currentPen = GreenPen;
			currentBrush = GreenBrush;
		}
		
		void btnWhite_Click(System.Object sender, System.EventArgs e)
		{
			currentPen = WhitePen;
			currentBrush = WhiteBrush;
		}
		
		void btnOrange_Click(System.Object sender, System.EventArgs e)
		{
			currentPen = OrangePen;
			currentBrush = OrangeBrush;
		}
		
		void btnClear_Click(System.Object sender, System.EventArgs e)
		{
			this.Refresh();
		}
    }
}
